﻿using DHTMLX.Scheduler;
using DHTMLX.Scheduler.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BookingChartTest2.Controllers
{
    public class TestController : Controller
    {
        // GET: Test
        public ActionResult Index()
        {
            var scheduler = new DHXScheduler(this);

            var room1 = new Room { Id = 1, key = "1", label = "room1" };
            var room2 = new Room { Id = 2, key = "2", label = "room2" };
            var rooms = new List<Room> { room1, room2 };

            var department1 = new Department { Id = 1, Title = "dep1" };
            var department2 = new Department { Id = 2, Title = "dep2" };
            department1.Rooms.Add(room1);
            department1.Rooms.Add(room2);
            department2.Rooms.Add(room1);
            department2.Rooms.Add(room2);
            var departments = new List<Department>();
            departments.Add(department1);
            departments.Add(department2);

            var timeline = new TimelineView("timeline", "room_id");
            timeline.FolderEventsAvailable = false;
            timeline.SectionAutoheight = false;
            timeline.RenderMode = TimelineView.RenderModes.Tree;
            foreach (var department in departments)
            {
                TimelineUnit section = new TimelineUnit(department.Id, department.Title, false);// defines the header of the folder
                timeline.AddOption(section);
                section.AddOptions(department.Rooms.Select(r => new TimelineUnit(r.Id, r.label)));//'Rooms' in the name of model data table
            }
            scheduler.Views.Add(timeline);

            return View(scheduler);
        }
    }

    public class Department
    {
        public Department()
        {
            Rooms = new List<Room>();
        }

        public int Id { get; set; }
        public string Title { get; set; }
        public List<Room> Rooms { get; set; }
    }

    public class Room
    {
        public int Id { get; set; }
        public string key { get; set; }
        public string label { get; set; }
    }
}